leetcode - 1870. Minimum Speed to Arrive on Time

Description

You are given a floating-point number hour, representing the amount of time you have to reach the office. To commute to the office, you must take n trains in sequential order. You are also given an integer array dist of length n, where dist[i] describes the distance (in kilometers) of the ith train ride.

Each train can only depart at an integer hour, so you may need to wait in between each train ride.

For example, if the 1st train ride takes 1.5 hours, you must wait for an additional 0.5 hours before you can depart on the 2nd train ride at the 2 hour mark.

Return the minimum positive integer speed (in kilometers per hour) that all the trains must travel at for you to reach the office on time, or -1 if it is impossible to be on time.

Tests are generated such that the answer will not exceed 107 and hour will have at most two digits after the decimal point.

Example 1:

复制代码
Input: dist = [1,3,2], hour = 6
Output: 1
Explanation: At speed 1:
- The first train ride takes 1/1 = 1 hour.
- Since we are already at an integer hour, we depart immediately at the 1 hour mark. The second train takes 3/1 = 3 hours.
- Since we are already at an integer hour, we depart immediately at the 4 hour mark. The third train takes 2/1 = 2 hours.
- You will arrive at exactly the 6 hour mark.

Example 2:

复制代码
Input: dist = [1,3,2], hour = 2.7
Output: 3
Explanation: At speed 3:
- The first train ride takes 1/3 = 0.33333 hours.
- Since we are not at an integer hour, we wait until the 1 hour mark to depart. The second train ride takes 3/3 = 1 hour.
- Since we are already at an integer hour, we depart immediately at the 2 hour mark. The third train takes 2/3 = 0.66667 hours.
- You will arrive at the 2.66667 hour mark.

Example 3:

复制代码
Input: dist = [1,3,2], hour = 1.9
Output: -1
Explanation: It is impossible because the earliest the third train can depart is at the 2 hour mark.

Constraints:

复制代码
n == dist.length
1 <= n <= 10^5
1 <= dist[i] <= 10^5
1 <= hour <= 10^9
There will be at most two digits after the decimal point in hour.

Solution

Since speed is positive integer, and for each speed we know whether this speed can get us to the destination within give time or not, we could use binary search to find the optimal speed. Try to find the smallest speed that is valid.

To start searching, firstly we need to determine the search range. I used some maths to calculate the range, but actually use [1, 10^7] would be easier.

Time complexity: o ( log ⁡ n ) o(\log n) o(logn), where n ∈ [ 1 , 1 0 7 ] n \in [1, 10^7] n∈[1,107]

Space complexity: o ( 1 ) o(1) o(1)

Code

python3 复制代码
class Solution:
    def is_valid(self, speed: int, dist: list, hour: float) -> bool:
        """
        Decide whether using this speed is valid or not
        """
        sum_of_time = 0
        for each_dist in dist[:-1]:
            sum_of_time += math.ceil(each_dist / speed)
        sum_of_time += dist[-1] / speed
        return True if sum_of_time <= hour else False


    def minSpeedOnTime(self, dist: List[int], hour: float) -> int:
        if hour - len(dist) + 1 <= 0:
            return -1

        import math
        left = max(math.floor(sum(dist) / hour), 1)
        right = max(max(dist), math.ceil(dist[-1] / (hour - len(dist) + 1)))
        while left < right:
            mid = (left + right) >> 1
            if not self.is_valid(mid, dist, hour):
                left = mid + 1
            else:
                right = mid
        mid = (left + right) >> 1
        if self.is_valid(mid, dist, hour):
            return mid
        return -1
相关推荐
飞桨PaddlePaddle2 小时前
Wan2.1和HunyuanVideo文生视频模型算法解析与功能体验丨前沿多模态模型开发与应用实战第六期
人工智能·算法·百度·音视频·paddlepaddle·飞桨·deepseek
Starry_hello world3 小时前
C++ 快速幂算法
c++·算法·有问必答
石去皿3 小时前
力扣hot100 91-100记录
算法·leetcode·职场和发展
圣保罗的大教堂5 小时前
leetcode 2799. 统计完全子数组的数目 中等
leetcode
SsummerC5 小时前
【leetcode100】组合总和Ⅳ
数据结构·python·算法·leetcode·动态规划
YuCaiH5 小时前
数组理论基础
笔记·leetcode·c·数组
2301_807611496 小时前
77. 组合
c++·算法·leetcode·深度优先·回溯
SsummerC7 小时前
【leetcode100】零钱兑换Ⅱ
数据结构·python·算法·leetcode·动态规划
好易学·数据结构8 小时前
可视化图解算法:二叉树的最大深度(高度)
数据结构·算法·二叉树·最大高度·最大深度·二叉树高度·二叉树深度
程序员-King.8 小时前
day47—双指针-平方数之和(LeetCode-633)
算法·leetcode